summaryrefslogtreecommitdiffstats
path: root/git-bisect.html
diff options
context:
space:
mode:
authorJunio C Hamano <junio@hera.kernel.org>2009-03-22 08:21:41 +0000
committerJunio C Hamano <junio@hera.kernel.org>2009-03-22 08:21:41 +0000
commitfd83b8ef73da0d282d4242ad34ac95bb690587d5 (patch)
treea3e4f2a7132d445a6fa000622bdd64758afe2754 /git-bisect.html
parent5217a27c7b67482f763976c9d9c67d66438e3090 (diff)
downloadgit-htmldocs-fd83b8ef73da0d282d4242ad34ac95bb690587d5.tar.gz
Autogenerated HTML docs for v1.6.2.1-299-g88f78
Diffstat (limited to 'git-bisect.html')
-rw-r--r--git-bisect.html173
1 files changed, 89 insertions, 84 deletions
diff --git a/git-bisect.html b/git-bisect.html
index a2e55ce19..cdf900358 100644
--- a/git-bisect.html
+++ b/git-bisect.html
@@ -314,7 +314,7 @@ git-bisect(1) Manual Page
<h2>NAME</h2>
<div class="sectionbody">
<p>git-bisect -
- Find the change that introduced a bug by binary search
+ Find by binary search the change that introduced a bug
</p>
</div>
</div>
@@ -346,7 +346,8 @@ old "good" commit object name and a later "bad" commit object name.</p></div>
<div class="para"><p>Use "git bisect" to get a short usage description, and "git bisect
help" or "git bisect -h" to get a long usage description.</p></div>
<h3 id="_basic_bisect_commands_start_bad_good">Basic bisect commands: start, bad, good</h3><div style="clear:left"></div>
-<div class="para"><p>The way you use it is:</p></div>
+<div class="para"><p>Using the Linux kernel tree as an example, basic use of the bisect
+command is as follows:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect start
@@ -354,121 +355,125 @@ $ git bisect bad # Current version is bad
$ git bisect good v2.6.13-rc2 # v2.6.13-rc2 was the last version
# tested that was good</tt></pre>
</div></div>
-<div class="para"><p>When you give at least one bad and one good versions, it will bisect
-the revision tree and say something like:</p></div>
+<div class="para"><p>When you have specified at least one bad and one good version, the
+command bisects the revision tree and outputs something similar to
+the following:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>Bisecting: 675 revisions left to test after this</tt></pre>
</div></div>
-<div class="para"><p>and check out the state in the middle. Now, compile that kernel, and
-boot it. Now, let's say that this booted kernel works fine, then just
-do</p></div>
+<div class="para"><p>The state in the middle of the set of revisions is then checked out.
+You would now compile that kernel and boot it. If the booted kernel
+works correctly, you would then issue the following command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect good # this one is good</tt></pre>
</div></div>
-<div class="para"><p>which will now say</p></div>
+<div class="para"><p>The output of this command would be something similar to the following:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>Bisecting: 337 revisions left to test after this</tt></pre>
</div></div>
-<div class="para"><p>and you continue along, compiling that one, testing it, and depending
-on whether it is good or bad, you say "git bisect good" or "git bisect
-bad", and ask for the next bisection.</p></div>
-<div class="para"><p>Until you have no more left, and you'll have been left with the first
-bad kernel rev in "refs/bisect/bad".</p></div>
+<div class="para"><p>You keep repeating this process, compiling the tree, testing it, and
+depending on whether it is good or bad issuing the command "git bisect good"
+or "git bisect bad" to ask for the next bisection.</p></div>
+<div class="para"><p>Eventually there will be no more revisions left to bisect, and you
+will have been left with the first bad kernel revision in "refs/bisect/bad".</p></div>
<h3 id="_bisect_reset">Bisect reset</h3><div style="clear:left"></div>
-<div class="para"><p>Oh, and then after you want to reset to the original head, do a</p></div>
+<div class="para"><p>To return to the original head after a bisect session, you issue the
+following command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect reset</tt></pre>
</div></div>
-<div class="para"><p>to get back to the original branch, instead of being on the bisection
-commit ("git bisect start" will do that for you too, actually: it will
-reset the bisection state).</p></div>
+<div class="para"><p>This resets the tree to the original branch instead of being on the
+bisection commit ("git bisect start" will also do that, as it resets
+the bisection state).</p></div>
<h3 id="_bisect_visualize">Bisect visualize</h3><div style="clear:left"></div>
-<div class="para"><p>During the bisection process, you can say</p></div>
+<div class="para"><p>To see the currently remaining suspects in <em>gitk</em>, the following command
+is issued during the bisection process:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect visualize</tt></pre>
</div></div>
-<div class="para"><p>to see the currently remaining suspects in <em>gitk</em>. <tt>visualize</tt> is a bit
-too long to type and <tt>view</tt> is provided as a synonym.</p></div>
-<div class="para"><p>If <em>DISPLAY</em> environment variable is not set, <em>git log</em> is used
-instead. You can even give command line options such as <tt>-p</tt> and
+<div class="para"><p><tt>view</tt> may also be used as a synonym for <tt>visualize</tt>.</p></div>
+<div class="para"><p>If the <em>DISPLAY</em> environment variable is not set, <em>git log</em> is used
+instead. You can also give command line options such as <tt>-p</tt> and
<tt>--stat</tt>.</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect view --stat</tt></pre>
</div></div>
<h3 id="_bisect_log_and_bisect_replay">Bisect log and bisect replay</h3><div style="clear:left"></div>
-<div class="para"><p>The good/bad input is logged, and</p></div>
+<div class="para"><p>After having marked revisions as good or bad, you issue the following
+command to show what has been done so far:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect log</tt></pre>
</div></div>
-<div class="para"><p>shows what you have done so far. You can truncate its output somewhere
-and save it in a file, and run</p></div>
+<div class="para"><p>If you discover that you made a mistake in specifying the status of a
+revision, you can save the output of this command to a file, edit it to
+remove the incorrect entries, and then issue the following commands to
+return to a corrected state:</p></div>
<div class="listingblock">
<div class="content">
-<pre><tt>$ git bisect replay that-file</tt></pre>
+<pre><tt>$ git bisect reset
+$ git bisect replay that-file</tt></pre>
</div></div>
-<div class="para"><p>if you find later you made a mistake telling good/bad about a
-revision.</p></div>
-<h3 id="_avoiding_to_test_a_commit">Avoiding to test a commit</h3><div style="clear:left"></div>
-<div class="para"><p>If in a middle of bisect session, you know what the bisect suggested
-to try next is not a good one to test (e.g. the change the commit
+<h3 id="_avoiding_testing_a_commit">Avoiding testing a commit</h3><div style="clear:left"></div>
+<div class="para"><p>If in the middle of a bisect session, you know that the next suggested
+revision is not a good one to test (e.g. the change the commit
introduces is known not to work in your environment and you know it
does not have anything to do with the bug you are chasing), you may
-want to find a near-by commit and try that instead.</p></div>
-<div class="para"><p>It goes something like this:</p></div>
+want to find a nearby commit and try that instead.</p></div>
+<div class="para"><p>For example:</p></div>
<div class="listingblock">
<div class="content">
-<pre><tt>$ git bisect good/bad # previous round was good/bad.
+<pre><tt>$ git bisect good/bad # previous round was good or bad.
Bisecting: 337 revisions left to test after this
$ git bisect visualize # oops, that is uninteresting.
-$ git reset --hard HEAD~3 # try 3 revs before what
+$ git reset --hard HEAD~3 # try 3 revisions before what
# was suggested</tt></pre>
</div></div>
-<div class="para"><p>Then compile and test the one you chose to try. After that, tell
-bisect what the result was as usual.</p></div>
+<div class="para"><p>Then compile and test the chosen revision. Afterwards the revision
+is marked as good or bad in the usual manner.</p></div>
<h3 id="_bisect_skip">Bisect skip</h3><div style="clear:left"></div>
-<div class="para"><p>Instead of choosing by yourself a nearby commit, you may just want git
-to do it for you using:</p></div>
+<div class="para"><p>Instead of choosing by yourself a nearby commit, you can ask git
+to do it for you by issuing the command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect skip # Current version cannot be tested</tt></pre>
</div></div>
<div class="para"><p>But computing the commit to test may be slower afterwards and git may
-eventually not be able to tell the first bad among a bad and one or
-more "skip"ped commits.</p></div>
+eventually not be able to tell the first bad commit among a bad commit
+and one or more skipped commits.</p></div>
<div class="para"><p>You can even skip a range of commits, instead of just one commit,
using the "<em>&lt;commit1&gt;</em>..<em>&lt;commit2&gt;</em>" notation. For example:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect skip v2.5..v2.6</tt></pre>
</div></div>
-<div class="para"><p>would mean that no commit between <tt>v2.5</tt> excluded and <tt>v2.6</tt> included
-can be tested.</p></div>
-<div class="para"><p>Note that if you want to also skip the first commit of a range you can
-use something like:</p></div>
+<div class="para"><p>The effect of this would be that no commit between <tt>v2.5</tt> excluded and
+<tt>v2.6</tt> included could be tested.</p></div>
+<div class="para"><p>Note that if you also want to skip the first commit of the range you
+would issue the command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect skip v2.5 v2.5..v2.6</tt></pre>
</div></div>
-<div class="para"><p>and the commit pointed to by <tt>v2.5</tt> will be skipped too.</p></div>
+<div class="para"><p>This would cause the commits between <tt>v2.5</tt> included and <tt>v2.6</tt> included
+to be skipped.</p></div>
<h3 id="_cutting_down_bisection_by_giving_more_parameters_to_bisect_start">Cutting down bisection by giving more parameters to bisect start</h3><div style="clear:left"></div>
-<div class="para"><p>You can further cut down the number of trials if you know what part of
-the tree is involved in the problem you are tracking down, by giving
-paths parameters when you say <tt>bisect start</tt>, like this:</p></div>
+<div class="para"><p>You can further cut down the number of trials, if you know what part of
+the tree is involved in the problem you are tracking down, by specifying
+path parameters when issuing the <tt>bisect start</tt> command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect start -- arch/i386 include/asm-i386</tt></pre>
</div></div>
-<div class="para"><p>If you know beforehand more than one good commits, you can narrow the
-bisect space down without doing the whole tree checkout every time you
-give good commits. You give the bad revision immediately after <tt>start</tt>
-and then you give all the good revisions you have:</p></div>
+<div class="para"><p>If you know beforehand more than one good commit, you can narrow the
+bisect space down by specifying all of the good commits immediately after
+the bad commit when issuing the <tt>bisect start</tt> command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect start v2.6.20-rc6 v2.6.20-rc4 v2.6.20-rc1 --
@@ -477,33 +482,33 @@ and then you give all the good revisions you have:</p></div>
</div></div>
<h3 id="_bisect_run">Bisect run</h3><div style="clear:left"></div>
<div class="para"><p>If you have a script that can tell if the current source code is good
-or bad, you can automatically bisect using:</p></div>
+or bad, you can bisect by issuing the command:</p></div>
<div class="listingblock">
<div class="content">
<pre><tt>$ git bisect run my_script arguments</tt></pre>
</div></div>
-<div class="para"><p>Note that the "run" script (<tt>my_script</tt> in the above example) should
-exit with code 0 in case the current source code is good. Exit with a
+<div class="para"><p>Note that the script (<tt>my_script</tt> in the above example) should
+exit with code 0 if the current source code is good, and exit with a
code between 1 and 127 (inclusive), except 125, if the current
source code is bad.</p></div>
-<div class="para"><p>Any other exit code will abort the automatic bisect process. (A
-program that does "exit(-1)" leaves $? = 255, see exit(3) manual page,
-the value is chopped with "&amp; 0377".)</p></div>
+<div class="para"><p>Any other exit code will abort the bisect process. It should be noted
+that a program that terminates via "exit(-1)" leaves $? = 255, (see the
+exit(3) manual page), as the value is chopped with "&amp; 0377".</p></div>
<div class="para"><p>The special exit code 125 should be used when the current source code
-cannot be tested. If the "run" script exits with this code, the current
-revision will be skipped, see <tt>git bisect skip</tt> above.</p></div>
-<div class="para"><p>You may often find that during bisect you want to have near-constant
-tweaks (e.g., s/#define DEBUG 0/#define DEBUG 1/ in a header file, or
-"revision that does not have this commit needs this patch applied to
-work around other problem this bisection is not interested in")
-applied to the revision being tested.</p></div>
+cannot be tested. If the script exits with this code, the current
+revision will be skipped (see <tt>git bisect skip</tt> above).</p></div>
+<div class="para"><p>You may often find that during a bisect session you want to have
+temporary modifications (e.g. s/#define DEBUG 0/#define DEBUG 1/ in a
+header file, or "revision that does not have this commit needs this
+patch applied to work around another problem this bisection is not
+interested in") applied to the revision being tested.</p></div>
<div class="para"><p>To cope with such a situation, after the inner <em>git bisect</em> finds the
-next revision to test, with the "run" script, you can apply that tweak
-before compiling, run the real test, and after the test decides if the
-revision (possibly with the needed tweaks) passed the test, rewind the
-tree to the pristine state. Finally the "run" script can exit with
-the status of the real test to let the "git bisect run" command loop to
-determine the outcome.</p></div>
+next revision to test, the script can apply the patch
+before compiling, run the real test, and afterwards decide if the
+revision (possibly with the needed patch) passed the test and then
+rewind the tree to the pristine state. Finally the script should exit
+with the status of the real test to let the "git bisect run" command loop
+determine the eventual outcome of the bisect session.</p></div>
</div>
<h2 id="_examples">EXAMPLES</h2>
<div class="sectionbody">
@@ -536,18 +541,18 @@ Automatically bisect a broken test suite:
<div class="content">
<pre><tt>$ cat ~/test.sh
#!/bin/sh
-make || exit 125 # this "skip"s broken builds
+make || exit 125 # this skips broken builds
make test # "make test" runs the test suite
$ git bisect start v1.3 v1.1 -- # v1.3 is bad, v1.1 is good
$ git bisect run ~/test.sh</tt></pre>
</div></div>
<div class="para"><p>Here we use a "test.sh" custom script. In this script, if "make"
-fails, we "skip" the current commit.</p></div>
-<div class="para"><p>It's safer to use a custom script outside the repo to prevent
+fails, we skip the current commit.</p></div>
+<div class="para"><p>It is safer to use a custom script outside the repository to prevent
interactions between the bisect, make and test processes and the
script.</p></div>
-<div class="para"><p>And "make test" should "exit 0", if the test suite passes, and
-"exit 1" (for example) otherwise.</p></div>
+<div class="para"><p>"make test" should "exit 0", if the test suite passes, and
+"exit 1" otherwise.</p></div>
</li>
<li>
<p>
@@ -557,16 +562,16 @@ Automatically bisect a broken test case:
<div class="content">
<pre><tt>$ cat ~/test.sh
#!/bin/sh
-make || exit 125 # this "skip"s broken builds
+make || exit 125 # this skips broken builds
~/check_test_case.sh # does the test case passes ?
$ git bisect start HEAD HEAD~10 -- # culprit is among the last 10
$ git bisect run ~/test.sh</tt></pre>
</div></div>
-<div class="para"><p>Here "check_test_case.sh" should "exit 0", if the test case passes,
-and "exit 1" (for example) otherwise.</p></div>
-<div class="para"><p>It's safer if both "test.sh" and "check_test_case.sh" scripts are
-outside the repo to prevent interactions between the bisect, make and
-test processes and the scripts.</p></div>
+<div class="para"><p>Here "check_test_case.sh" should "exit 0" if the test case passes,
+and "exit 1" otherwise.</p></div>
+<div class="para"><p>It is safer if both "test.sh" and "check_test_case.sh" scripts are
+outside the repository to prevent interactions between the bisect,
+make and test processes and the scripts.</p></div>
</li>
<li>
<p>
@@ -595,7 +600,7 @@ $ git bisect run sh -c "make || exit 125; ~/check_test_case.sh"</tt></pre>
</div>
<div id="footer">
<div id="footer-text">
-Last updated 2009-03-06 08:20:41 UTC
+Last updated 2009-03-22 08:21:21 UTC
</div>
</div>
</body>